DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Scheduler - SignalR Service

This demo shows how you can use a SignalR service to synchronize appointments across different devices. To emulate such a setup, each JavaScript Scheduler on this page reads data from its own separate data store. Changes made in one control are repeated in the other and persist until the browser session has expired.

Backend API
$(() => { $.type = $.type || function getType(obj) { if (obj == null) { return `${obj}`; } return typeof obj; }; const BASE_PATH = 'https://js.devexpress.com/Demos/NetCore/'; const url = `${BASE_PATH}api/SchedulerSignalR`; const createScheduler = function (index) { $(`#scheduler${index}`).dxScheduler({ timeZone: 'America/Los_Angeles', dataSource: DevExpress.data.AspNet.createStore({ key: 'AppointmentId', loadUrl: url, insertUrl: url, updateUrl: url, deleteUrl: url, onBeforeSend(method, ajaxOptions) { ajaxOptions.xhrFields = { withCredentials: true }; }, }), remoteFiltering: true, views: ['day', 'workWeek'], currentView: 'day', currentDate: new Date(2021, 3, 27), startDayHour: 9, endDayHour: 19, height: 600, dateSerializationFormat: 'yyyy-MM-ddTHH:mm:ssZ', textExpr: 'Text', descriptionExpr: 'Description', startDateExpr: 'StartDate', endDateExpr: 'EndDate', allDayExpr: 'AllDay', }); }; createScheduler(1); createScheduler(2); const store1 = $('#scheduler1').dxScheduler('getDataSource').store(); const store2 = $('#scheduler2').dxScheduler('getDataSource').store(); const connection = new signalR.HubConnectionBuilder() .withUrl(`${BASE_PATH}schedulerSignalRHub`, { skipNegotiation: true, transport: signalR.HttpTransportType.WebSockets, }) .configureLogging(signalR.LogLevel.Information) .build(); connection.start() .then(() => { connection.on('update', (key, data) => { store1.push([{ type: 'update', key, data }]); store2.push([{ type: 'update', key, data }]); }); connection.on('insert', (data) => { store1.push([{ type: 'insert', data }]); store2.push([{ type: 'insert', data }]); }); connection.on('remove', (key) => { store1.push([{ type: 'remove', key }]); store2.push([{ type: 'remove', key }]); }); }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <script src="../signalr-session-id.js"></script> <script src="js/signalr.js"></script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.3"></script> <script src="https://unpkg.com/devextreme-aspnet-data@5.0.0/js/dx.aspnet.data.js"></script> <script src="/shared/anti-forgery/jquery-override.js"></script> <script src="index.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="schedulers"> <div class="column-1"> <div id="scheduler1"></div> </div> <div class="column-2"> <div id="scheduler2"></div> </div> </div> </div> </body> </html>
.schedulers { display: flex; } .column-1 { padding-right: 5px; } .column-2 { padding-left: 5px; } .dx-scheduler-small .dx-scheduler-view-switcher.dx-tabs { display: table; }
using DevExtreme.AspNet.Data; using DevExtreme.AspNet.Mvc; using DevExtreme.MVC.Demos.Hubs; using DevExtreme.MVC.Demos.Models; using Microsoft.AspNet.SignalR; using Newtonsoft.Json; using System; using System.Collections.Generic; using System.Linq; using System.Net; using System.Net.Http; using System.Net.Http.Formatting; using System.Web; using System.Web.Http; namespace DevExtreme.MVC.Demos.Controllers.ApiControllers { public class SchedulerSignalRController : ApiController { InMemoryAppointmentsDataContext _data = new InMemoryAppointmentsDataContext(); IHubContext hubContext; public SchedulerSignalRController() { hubContext = GlobalHost.ConnectionManager.GetHubContext<SchedulerSignalRHub>(); } [HttpGet] public HttpResponseMessage Get(DataSourceLoadOptions loadOptions) { return Request.CreateResponse(DataSourceLoader.Load(_data.Appointments, loadOptions)); } [HttpPost] public HttpResponseMessage Post(FormDataCollection form) { var values = form.Get("values"); var newAppointment = new Appointment(); JsonConvert.PopulateObject(values, newAppointment); Validate(newAppointment); if(!ModelState.IsValid) return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage()); _data.Appointments.Add(newAppointment); _data.SaveChanges(); var groupName = GetGroupName(); if(groupName != null) { hubContext.Clients.Group(GetGroupName()).insert(newAppointment); } return Request.CreateResponse(HttpStatusCode.Created); } [HttpPut] public HttpResponseMessage Put(FormDataCollection form) { var key = Convert.ToInt32(form.Get("key")); var values = form.Get("values"); var appointment = _data.Appointments.First(a => a.AppointmentId == key); JsonConvert.PopulateObject(values, appointment); Validate(appointment); if(!ModelState.IsValid) return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage()); _data.SaveChanges(); var groupName = GetGroupName(); if(groupName != null) { hubContext.Clients.Group(GetGroupName()).update(key, appointment); } return Request.CreateResponse(HttpStatusCode.OK); } [HttpDelete] public void Delete(FormDataCollection form) { var key = Convert.ToInt32(form.Get("key")); var appointment = _data.Appointments.First(a => a.AppointmentId == key); _data.Appointments.Remove(appointment); _data.SaveChanges(); var groupName = GetGroupName(); if(groupName != null) { hubContext.Clients.Group(GetGroupName()).remove(key); } } string GetGroupName() { var cookie = Request.Headers.GetCookies(SchedulerSignalRHub.GroupIdKey).FirstOrDefault(); if(cookie != null) { return cookie[SchedulerSignalRHub.GroupIdKey].Value; } return null; } } }
using System; using System.Threading.Tasks; using System.Web; using Microsoft.AspNet.SignalR; using DevExpress.Data.Utils; namespace DevExtreme.MVC.Demos.Hubs { public class SchedulerSignalRHub : Hub { public static string GroupIdKey = "dx-SchedulerSignalRHub-groupId"; private static readonly NonCryptographicRandom random = NonCryptographicRandom.System; public override Task OnConnected() { Cookie cookie; Context.RequestCookies.TryGetValue(GroupIdKey, out cookie); string groupId; if(cookie != null) { groupId = cookie.Value; } else { groupId = random.Next(0, int.MaxValue).ToString(); var newCookie = new HttpCookie(GroupIdKey, groupId); Context.Request.GetHttpContext().Response.Cookies.Add(newCookie); } Groups.Add(Context.ConnectionId, groupId); return base.OnConnected(); } } }

Follow the steps below to implement this functionality. Note again that this demo repeats all steps twice for the two Schedulers. Your project will have a single control and a single store.

  1. Configure a CustomStore. In this demo, we use the createStore method (part of the DevExtreme.AspNet.data extension).

  2. Create the JavaScript Scheduler and use its dataSource property to bind it to the store instance.

  3. When a push notification is received, call the store's push(changes) method to update the store's data (see the connection.on event handlers).

For server-side configuration, refer to the ASP.NET MVC version of this demo.

For more information about integration with push services, refer to the following help topic: Integration with Push Services.

<template>
<div class="schedulers">
<div class="column-1">
<DxScheduler
time-zone="America/Los_Angeles"
:data-source="store1"
:current-date="currentDate"
:views="views"
:height="600"
:start-day-hour="9"
:end-day-hour="19"
:remote-filtering="true"
current-view="day"
date-serialization-format="yyyy-MM-ddTHH:mm:ssZ"
text-expr="Text"
description-expr="Description"
start-date-expr="StartDate"
end-date-expr="EndDate"
all-day-expr="AllDay"
/>
</div>
<div class="column-2">
<DxScheduler
time-zone="America/Los_Angeles"
:data-source="store2"
:current-date="currentDate"
:views="views"
:height="600"
:start-day-hour="9"
:end-day-hour="19"
:remote-filtering="true"
current-view="day"
date-serialization-format="yyyy-MM-ddTHH:mm:ssZ"
text-expr="Text"
start-date-expr="StartDate"
end-date-expr="EndDate"
all-day-expr="AllDay"
/>
</div>
</div>
</template>
<script setup lang="ts">
import DxScheduler from 'devextreme-vue/scheduler';
import { createStore as createAspNetDataStore } from 'devextreme-aspnet-data-nojquery';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
const views = ['day', 'workWeek'];
const currentDate = new Date(2021, 3, 27);
const BASE_PATH = 'https://js.devexpress.com/Demos/NetCore/';
const url = `${BASE_PATH}api/SchedulerSignalR`;
const createStore = () => createAspNetDataStore({
key: 'AppointmentId',
loadUrl: url,
insertUrl: url,
updateUrl: url,
deleteUrl: url,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const store1 = createStore();
const store2 = createStore();
const connection = new HubConnectionBuilder()
.withUrl(`${BASE_PATH}schedulerSignalRHub`, {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
connection
.start()
.then(() => {
connection.on('update', (key, data) => {
store1.push([{ type: 'update', key, data }]);
store2.push([{ type: 'update', key, data }]);
});
connection.on('insert', (data) => {
store1.push([{ type: 'insert', data }]);
store2.push([{ type: 'insert', data }]);
});
connection.on('remove', (key) => {
store1.push([{ type: 'remove', key }]);
store2.push([{ type: 'remove', key }]);
});
});
</script>
<style scoped>
.schedulers {
display: flex;
}
.column-1 {
padding-right: 5px;
}
.column-2 {
padding-left: 5px;
}
.dx-scheduler-small .dx-scheduler-view-switcher.dx-tabs {
display: table;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs',
'tslib': 'npm:tslib/tslib.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.0.0/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'@aspnet/signalr': {
main: 'index.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { createApp } from 'vue';
import App from './App.vue';
import 'anti-forgery';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="../signalr-session-id.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using DevExtreme.MVC.Demos.Hubs;
using DevExtreme.MVC.Demos.Models;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class SchedulerSignalRController : ApiController {
InMemoryAppointmentsDataContext _data = new InMemoryAppointmentsDataContext();
IHubContext hubContext;
public SchedulerSignalRController() {
hubContext = GlobalHost.ConnectionManager.GetHubContext<SchedulerSignalRHub>();
}
[HttpGet]
public HttpResponseMessage Get(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(_data.Appointments, loadOptions));
}
[HttpPost]
public HttpResponseMessage Post(FormDataCollection form) {
var values = form.Get("values");
var newAppointment = new Appointment();
JsonConvert.PopulateObject(values, newAppointment);
Validate(newAppointment);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_data.Appointments.Add(newAppointment);
_data.SaveChanges();
var groupName = GetGroupName();
if(groupName != null) {
hubContext.Clients.Group(GetGroupName()).insert(newAppointment);
}
return Request.CreateResponse(HttpStatusCode.Created);
}
[HttpPut]
public HttpResponseMessage Put(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var appointment = _data.Appointments.First(a => a.AppointmentId == key);
JsonConvert.PopulateObject(values, appointment);
Validate(appointment);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_data.SaveChanges();
var groupName = GetGroupName();
if(groupName != null) {
hubContext.Clients.Group(GetGroupName()).update(key, appointment);
}
return Request.CreateResponse(HttpStatusCode.OK);
}
[HttpDelete]
public void Delete(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var appointment = _data.Appointments.First(a => a.AppointmentId == key);
_data.Appointments.Remove(appointment);
_data.SaveChanges();
var groupName = GetGroupName();
if(groupName != null) {
hubContext.Clients.Group(GetGroupName()).remove(key);
}
}
string GetGroupName() {
var cookie = Request.Headers.GetCookies(SchedulerSignalRHub.GroupIdKey).FirstOrDefault();
if(cookie != null) {
return cookie[SchedulerSignalRHub.GroupIdKey].Value;
}
return null;
}
}
}
using System;
using System.Threading.Tasks;
using System.Web;
using Microsoft.AspNet.SignalR;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Hubs {
public class SchedulerSignalRHub : Hub {
public static string GroupIdKey = "dx-SchedulerSignalRHub-groupId";
private static readonly NonCryptographicRandom random = NonCryptographicRandom.System;
public override Task OnConnected() {
Cookie cookie;
Context.RequestCookies.TryGetValue(GroupIdKey, out cookie);
string groupId;
if(cookie != null) {
groupId = cookie.Value;
} else {
groupId = random.Next(0, int.MaxValue).ToString();
var newCookie = new HttpCookie(GroupIdKey, groupId);
Context.Request.GetHttpContext().Response.Cookies.Add(newCookie);
}
Groups.Add(Context.ConnectionId, groupId);
return base.OnConnected();
}
}
}

import React from 'react';
import Scheduler from 'devextreme-react/scheduler';
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
const BASE_PATH = 'https://js.devexpress.com/Demos/NetCore/';
const url = `${BASE_PATH}api/SchedulerSignalR`;
const createStore = () => AspNetData.createStore({
key: 'AppointmentId',
loadUrl: url,
insertUrl: url,
updateUrl: url,
deleteUrl: url,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const store1 = createStore();
const store2 = createStore();
const currentDate = new Date(2021, 3, 27);
const views: SchedulerTypes.ViewType[] = ['day', 'workWeek'];
const connection = new HubConnectionBuilder()
.withUrl(`${BASE_PATH}schedulerSignalRHub`, {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
connection
.start()
.then(() => {
connection.on('update', (key, data) => {
store1.push([{ type: 'update', key, data }]);
store2.push([{ type: 'update', key, data }]);
});
connection.on('insert', (data) => {
store1.push([{ type: 'insert', data }]);
store2.push([{ type: 'insert', data }]);
});
connection.on('remove', (key) => {
store1.push([{ type: 'remove', key }]);
store2.push([{ type: 'remove', key }]);
});
});
const App = () => (
<div className="schedulers">
<div className="column-1">
<Scheduler
timeZone="America/Los_Angeles"
dataSource={store1}
views={views}
defaultCurrentView="day"
defaultCurrentDate={currentDate}
height={600}
startDayHour={9}
endDayHour={19}
remoteFiltering={true}
dateSerializationFormat="yyyy-MM-ddTHH:mm:ssZ"
textExpr="Text"
startDateExpr="StartDate"
descriptionExpr="Description"
endDateExpr="EndDate"
allDayExpr="AllDay"
/>
</div>
<div className="column-2">
<Scheduler
timeZone="America/Los_Angeles"
dataSource={store2}
views={views}
defaultCurrentView="day"
defaultCurrentDate={currentDate}
height={600}
startDayHour={9}
endDayHour={19}
remoteFiltering={true}
dateSerializationFormat="yyyy-MM-ddTHH:mm:ssZ"
textExpr="Text"
startDateExpr="StartDate"
endDateExpr="EndDate"
allDayExpr="AllDay"
/>
</div>
</div>
);
export default App;
import React from 'react';
import Scheduler from 'devextreme-react/scheduler';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
const BASE_PATH = 'https://js.devexpress.com/Demos/NetCore/';
const url = `${BASE_PATH}api/SchedulerSignalR`;
const createStore = () =>
AspNetData.createStore({
key: 'AppointmentId',
loadUrl: url,
insertUrl: url,
updateUrl: url,
deleteUrl: url,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const store1 = createStore();
const store2 = createStore();
const currentDate = new Date(2021, 3, 27);
const views = ['day', 'workWeek'];
const connection = new HubConnectionBuilder()
.withUrl(`${BASE_PATH}schedulerSignalRHub`, {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
connection.start().then(() => {
connection.on('update', (key, data) => {
store1.push([{ type: 'update', key, data }]);
store2.push([{ type: 'update', key, data }]);
});
connection.on('insert', (data) => {
store1.push([{ type: 'insert', data }]);
store2.push([{ type: 'insert', data }]);
});
connection.on('remove', (key) => {
store1.push([{ type: 'remove', key }]);
store2.push([{ type: 'remove', key }]);
});
});
const App = () => (
<div className="schedulers">
<div className="column-1">
<Scheduler
timeZone="America/Los_Angeles"
dataSource={store1}
views={views}
defaultCurrentView="day"
defaultCurrentDate={currentDate}
height={600}
startDayHour={9}
endDayHour={19}
remoteFiltering={true}
dateSerializationFormat="yyyy-MM-ddTHH:mm:ssZ"
textExpr="Text"
startDateExpr="StartDate"
descriptionExpr="Description"
endDateExpr="EndDate"
allDayExpr="AllDay"
/>
</div>
<div className="column-2">
<Scheduler
timeZone="America/Los_Angeles"
dataSource={store2}
views={views}
defaultCurrentView="day"
defaultCurrentDate={currentDate}
height={600}
startDayHour={9}
endDayHour={19}
remoteFiltering={true}
dateSerializationFormat="yyyy-MM-ddTHH:mm:ssZ"
textExpr="Text"
startDateExpr="StartDate"
endDateExpr="EndDate"
allDayExpr="AllDay"
/>
</div>
</div>
);
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
// eslint-disable-next-line import/no-unresolved
import 'anti-forgery';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs',
'tslib': 'npm:tslib/tslib.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.1.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'@aspnet/signalr': {
main: 'index.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
// eslint-disable-next-line import/no-unresolved
import 'anti-forgery';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="../signalr-session-id.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.schedulers {
display: flex;
}
.column-1 {
padding-right: 5px;
}
.column-2 {
padding-left: 5px;
}
.dx-scheduler-small .dx-scheduler-view-switcher.dx-tabs {
display: table;
}
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using DevExtreme.MVC.Demos.Hubs;
using DevExtreme.MVC.Demos.Models;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class SchedulerSignalRController : ApiController {
InMemoryAppointmentsDataContext _data = new InMemoryAppointmentsDataContext();
IHubContext hubContext;
public SchedulerSignalRController() {
hubContext = GlobalHost.ConnectionManager.GetHubContext<SchedulerSignalRHub>();
}
[HttpGet]
public HttpResponseMessage Get(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(_data.Appointments, loadOptions));
}
[HttpPost]
public HttpResponseMessage Post(FormDataCollection form) {
var values = form.Get("values");
var newAppointment = new Appointment();
JsonConvert.PopulateObject(values, newAppointment);
Validate(newAppointment);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_data.Appointments.Add(newAppointment);
_data.SaveChanges();
var groupName = GetGroupName();
if(groupName != null) {
hubContext.Clients.Group(GetGroupName()).insert(newAppointment);
}
return Request.CreateResponse(HttpStatusCode.Created);
}
[HttpPut]
public HttpResponseMessage Put(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var appointment = _data.Appointments.First(a => a.AppointmentId == key);
JsonConvert.PopulateObject(values, appointment);
Validate(appointment);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_data.SaveChanges();
var groupName = GetGroupName();
if(groupName != null) {
hubContext.Clients.Group(GetGroupName()).update(key, appointment);
}
return Request.CreateResponse(HttpStatusCode.OK);
}
[HttpDelete]
public void Delete(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var appointment = _data.Appointments.First(a => a.AppointmentId == key);
_data.Appointments.Remove(appointment);
_data.SaveChanges();
var groupName = GetGroupName();
if(groupName != null) {
hubContext.Clients.Group(GetGroupName()).remove(key);
}
}
string GetGroupName() {
var cookie = Request.Headers.GetCookies(SchedulerSignalRHub.GroupIdKey).FirstOrDefault();
if(cookie != null) {
return cookie[SchedulerSignalRHub.GroupIdKey].Value;
}
return null;
}
}
}
using System;
using System.Threading.Tasks;
using System.Web;
using Microsoft.AspNet.SignalR;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Hubs {
public class SchedulerSignalRHub : Hub {
public static string GroupIdKey = "dx-SchedulerSignalRHub-groupId";
private static readonly NonCryptographicRandom random = NonCryptographicRandom.System;
public override Task OnConnected() {
Cookie cookie;
Context.RequestCookies.TryGetValue(GroupIdKey, out cookie);
string groupId;
if(cookie != null) {
groupId = cookie.Value;
} else {
groupId = random.Next(0, int.MaxValue).ToString();
var newCookie = new HttpCookie(GroupIdKey, groupId);
Context.Request.GetHttpContext().Response.Cookies.Add(newCookie);
}
Groups.Add(Context.ConnectionId, groupId);
return base.OnConnected();
}
}
}

<div class="schedulers">
<div class="column-1">
<dx-scheduler
timeZone="America/Los_Angeles"
[dataSource]="store1"
[remoteFiltering]="true"
[views]="['day', 'workWeek']"
currentView="day"
[currentDate]="currentDate"
[startDayHour]="9"
[endDayHour]="19"
[height]="600"
textExpr="Text"
dateSerializationFormat="yyyy-MM-ddTHH:mm:ssZ"
descriptionExpr="Description"
startDateExpr="StartDate"
endDateExpr="EndDate"
allDayExpr="AllDay"
>
</dx-scheduler>
</div>
<div class="column-2">
<dx-scheduler
timeZone="America/Los_Angeles"
[dataSource]="store2"
[remoteFiltering]="true"
[views]="['day', 'workWeek']"
currentView="day"
[currentDate]="currentDate"
[startDayHour]="9"
[endDayHour]="19"
[height]="600"
dateSerializationFormat="yyyy-MM-ddTHH:mm:ssZ"
textExpr="Text"
startDateExpr="StartDate"
endDateExpr="EndDate"
allDayExpr="AllDay"
>
</dx-scheduler>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import { DxSchedulerModule } from 'devextreme-angular';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
import 'anti-forgery';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
const BASE_PATH = 'https://js.devexpress.com/Demos/NetCore/';
const url = `${BASE_PATH}api/SchedulerSignalR`;
const createStore = () => AspNetData.createStore({
key: 'AppointmentId',
loadUrl: url,
insertUrl: url,
updateUrl: url,
deleteUrl: url,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const store1 = createStore();
const store2 = createStore();
const connection = new HubConnectionBuilder()
.withUrl(`${BASE_PATH}schedulerSignalRHub`, {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
connection
.start()
.then(() => {
connection.on('update', (key, data) => {
store1.push([{ type: 'update', key, data }]);
store2.push([{ type: 'update', key, data }]);
});
connection.on('insert', (data) => {
store1.push([{ type: 'insert', data }]);
store2.push([{ type: 'insert', data }]);
});
connection.on('remove', (key) => {
store1.push([{ type: 'remove', key }]);
store2.push([{ type: 'remove', key }]);
});
});
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxSchedulerModule,
],
})
export class AppComponent {
store1: AspNetData.CustomStore = store1;
store2: AspNetData.CustomStore = store2;
currentDate = new Date(2021, 3, 27);
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .schedulers {
display: flex;
}
::ng-deep .column-1 {
padding-right: 5px;
}
::ng-deep .column-2 {
padding-left: 5px;
}
::ng-deep .dx-scheduler-small .dx-scheduler-view-switcher.dx-tabs {
display: table;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs/index.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.1.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
'npm:@aspnet/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="../signalr-session-id.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using DevExtreme.MVC.Demos.Hubs;
using DevExtreme.MVC.Demos.Models;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class SchedulerSignalRController : ApiController {
InMemoryAppointmentsDataContext _data = new InMemoryAppointmentsDataContext();
IHubContext hubContext;
public SchedulerSignalRController() {
hubContext = GlobalHost.ConnectionManager.GetHubContext<SchedulerSignalRHub>();
}
[HttpGet]
public HttpResponseMessage Get(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(_data.Appointments, loadOptions));
}
[HttpPost]
public HttpResponseMessage Post(FormDataCollection form) {
var values = form.Get("values");
var newAppointment = new Appointment();
JsonConvert.PopulateObject(values, newAppointment);
Validate(newAppointment);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_data.Appointments.Add(newAppointment);
_data.SaveChanges();
var groupName = GetGroupName();
if(groupName != null) {
hubContext.Clients.Group(GetGroupName()).insert(newAppointment);
}
return Request.CreateResponse(HttpStatusCode.Created);
}
[HttpPut]
public HttpResponseMessage Put(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var appointment = _data.Appointments.First(a => a.AppointmentId == key);
JsonConvert.PopulateObject(values, appointment);
Validate(appointment);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_data.SaveChanges();
var groupName = GetGroupName();
if(groupName != null) {
hubContext.Clients.Group(GetGroupName()).update(key, appointment);
}
return Request.CreateResponse(HttpStatusCode.OK);
}
[HttpDelete]
public void Delete(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var appointment = _data.Appointments.First(a => a.AppointmentId == key);
_data.Appointments.Remove(appointment);
_data.SaveChanges();
var groupName = GetGroupName();
if(groupName != null) {
hubContext.Clients.Group(GetGroupName()).remove(key);
}
}
string GetGroupName() {
var cookie = Request.Headers.GetCookies(SchedulerSignalRHub.GroupIdKey).FirstOrDefault();
if(cookie != null) {
return cookie[SchedulerSignalRHub.GroupIdKey].Value;
}
return null;
}
}
}
using System;
using System.Threading.Tasks;
using System.Web;
using Microsoft.AspNet.SignalR;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Hubs {
public class SchedulerSignalRHub : Hub {
public static string GroupIdKey = "dx-SchedulerSignalRHub-groupId";
private static readonly NonCryptographicRandom random = NonCryptographicRandom.System;
public override Task OnConnected() {
Cookie cookie;
Context.RequestCookies.TryGetValue(GroupIdKey, out cookie);
string groupId;
if(cookie != null) {
groupId = cookie.Value;
} else {
groupId = random.Next(0, int.MaxValue).ToString();
var newCookie = new HttpCookie(GroupIdKey, groupId);
Context.Request.GetHttpContext().Response.Cookies.Add(newCookie);
}
Groups.Add(Context.ConnectionId, groupId);
return base.OnConnected();
}
}
}